<?php
/*
	Plugin Name: CD Dating Comments
	Plugin URI: http://www.carpediem.fr/
	Description: Utilisez la puissance de la co-registration couplée à votre blog WordPress de rencontre !
	Author: PhilippeCD
	Version: 1.3
    Author URI: http://www.linkedin.com/in/phscreation
*/

if ( !class_exists('cd_dating_comments') ) {

	class cd_dating_comments
	{

		private $options;

		/**
		 * the Constructor
		 * @param void
		 * @return void
		 **/
		public function __construct()
		{
			add_action('admin_menu', array($this, 'adminLink')); // Admin menu link
			add_action('admin_init', array($this, 'adminInit')); // Admin options
			add_action('comment_post', array($this, 'coregLoad'), $IDcomment); // On comment post
			add_action('comment_form', array($this, 'checkboxDisplay') ); // On comment form display
        }

		/**
		 * Add the link into the admin menu
		 * @param void
		 * @return void
		 **/
		public function adminLink ()
		{
			add_menu_page( 'Coreg config', 'Coreg config', 'manage_options', 'my-coreg-admin', array($this, 'adminContent') );
		}

		/**
		 * Add checkbox under comment form
		 * @param void
		 * @return void
		 **/
		public function checkboxDisplay ()
		{
			echo '<p class="form-allowed-tags" style="vertical-align: middle;"><label for="coregCheckbox"><input type="checkbox" name="coreg" id="coregCheckbox" value="1" checked="checked" style="vertical-align: middle;"> Ouvrir un compte gratuit sur le messenger.</label></p>';
		}

		/**
		 * Display the configuration page into the admin
		 * @param void
		 * @return void
		 **/
		public function adminContent ()
		{

			// Coreg options
			$this->options = get_option( 'coreg' );

			// Get last permalink post
			 $args = array(
				'posts_per_pag' => 1,
				'offset' => 0,
				'orderby' => 'post_date',
				'order' => 'DESC',
				'post_type' => 'post',
				'post_status' => 'publish' );
			$myposts = get_posts( $args );
			$permalink = get_permalink($myposts[0]->ID);

			// Check 
			$checkResult = false;
			$result = wp_remote_get( $permalink );
			if ( !is_wp_error($result) && 200 == $result['response']['code'] ) {
				if ( preg_match('`<input type="checkbox" name="coreg"`', $result['body']) ) {
					$checkResult = true;
				}
			}
			?>

			<div class="wrap">
				<div id="icon-options-general" class="icon32"><br /></div>
				<h2>Configuration de la co-registration</h2>

					<?php if ( $checkResult == false ) : ?>
						<div class='updated fade' style="background: #FFEBE8; border-color: #CC0000;">
							<p><strong>Il semble que la case à cocher ne peut pas être ajoutée automatiquement au formulaire des commentaires.</strong></p>
							<p>Rendez-vous sur un post, et vérifiez que cette case à cocher est bien présente. Celle-ci est OBLIGATOIRE pour le fonctionnement du plugin.</p>
							<p>&nbsp;</p>
							<p>Voici le code à ajouter dans le formulaire de commentaire :</p>
							<blockquote>
								<code>
									&lt;p class="form-allowed-tags" style="vertical-align: middle;"><br />
									&nbsp;&nbsp;&nbsp;&nbsp;&lt;label for="coregCheckbox"><br />
									&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;input type="checkbox" name="coreg" id="coregCheckbox" value="1" checked="checked"> Ouvrir un compte gratuit sur le messenger.<br />
									&nbsp;&nbsp;&nbsp;&nbsp;&lt;/label><br />
									&lt;/p>
								</code>
							</blockquote>
						</div>
					<?php endif; ?>

					<?php if ( isset($_GET['settings-updated']) && $_GET['settings-updated'] == true ) : ?>
						<div class='updated fade' style="background: #82FBD3; border-color: #57C21F;">
							<p><strong>Configuration mise à jour avec succès.</strong></p>
						</div>
					<?php endif; ?>

				<form method="post" action="options.php">
					<?php
					// This prints out all hidden setting fields
					settings_fields( 'coreg_options' );   
					do_settings_sections( 'my-coreg-admin' );
					submit_button(); 
					?>
				</form>
			</div>

			<?php
		}

		/**
		 * Sanitize / Save the options
		 * @param void
		 * @return void
		 **/
		public function adminInit()
		{

			register_setting( 'coreg_options', 'coreg', array( $this, 'sanitize' ) );

			add_settings_section( 'coreg_compte_list', 'Compte Carpe Diem, tracking et reversement', array( $this, 'intro_cd' ), 'my-coreg-admin' );  
			add_settings_field( 'id_webmaster', 'ID Webmaster', array( $this, 'fieldIdWebmaster' ), 'my-coreg-admin', 'coreg_compte_list' );
			add_settings_field( 'tracker', 'Tracker', array( $this, 'fieldTracker' ), 'my-coreg-admin', 'coreg_compte_list' );
			add_settings_field( 'onshot', 'Mode de reversement', array( $this, 'fieldOneshot' ), 'my-coreg-admin', 'coreg_compte_list' );

			add_settings_section( 'coreg_options_list', 'Options spécifiques à la coreg', array( $this, 'intro_options' ), 'my-coreg-admin' );  
			add_settings_field( 'id_mb', 'Inscrire sur', array( $this, 'fieldIdMB' ), 'my-coreg-admin', 'coreg_options_list' );
			add_settings_field( 'destination', 'Envoyer le visiteur sur', array( $this, 'fieldDestination' ), 'my-coreg-admin', 'coreg_options_list' );

		}

		/** 
		 * Display ID webmaster field
		 * @param void
		 * @return void
		 **/
		public function fieldIdWebmaster()
		{
			printf(
				'<input type="text" id="id_webmaster" name="coreg[id_webmaster]" value="%s" />',
				isset( $this->options['id_webmaster'] ) ? esc_attr( $this->options['id_webmaster']) : ''
			);
		}

		/** 
		 * Display tracker field
		 * @param void
		 * @return void
		 **/
		public function fieldTracker()
		{
			printf(
				'<input type="text" id="tracker" name="coreg[tracker]" value="%s" />',
				isset( $this->options['tracker'] ) ? esc_attr( $this->options['tracker']) : ''
			);
		}

		/** 
		 * Display oneshot field
		 * @param void
		 * @return void
		 */
		public function fieldOneshot()
		{
			$oneshot = ( isset( $this->options['oneshot'] ) ) ? (int)$this->options['oneshot'] : 0;
			$optionOSChecked = ( $oneshot === 1 ) ? 'checked="checked"' : '';
			$optionRebillChecked = ( $oneshot === 0 ) ? 'checked="checked"' : '';
			printf(
				'<label title="Activer le mode oneshot"><input type="radio" name="coreg[oneshot]" value="1" %s> Mode oneshot</label><br /><label title="Activer le mode rebill"><input type="radio" name="coreg[oneshot]" value="0" %s> Mode rebill</label>',
				$optionOSChecked, $optionRebillChecked
			);
		}

		/** 
		 * Display ID MB field
		 * @param void
		 * @return void
		 **/
		public function fieldIdMB()
		{
			printf(
				'<input type="text" id="id_mb" name="coreg[id_mb]" value="%s" />',
				isset( $this->options['id_mb'] ) ? esc_attr( $this->options['id_mb']) : ''
			);
		}

		/** 
		 * Display destination field
		 * @param void
		 * @return void
		 */
		public function fieldDestination()
		{
			$destination = ( isset( $this->options['destination'] ) ) ? (string)$this->options['destination'] : 'cb30';
			$optionCBChecked = ( $destination == 'cb30' ) ? 'selected="selected"' : '';
			$optionExeChecked = ( $destination == 'exe' ) ? 'selected="selected"' : '';
			printf(
				'<select id="destination" name="coreg[destination]"><option value="cb30" %s>Formulaire CB30</option><option value="exe" %s>Messenger avec autologin</option></select>',
				$optionCBChecked, $optionExeChecked
			);
		}

		/**
		 * Sanitize each setting field as needed
		 * @param array $input Contains all settings fields as array keys
		 * @return void
		 **/
		public function sanitize( $input )
		{

			$sanitizedArray = array();

			if ( isset( $input['id_webmaster'] ) ) {
				$sanitizedArray['id_webmaster'] = (int)$input['id_webmaster'];
			}

			if ( isset( $input['tracker'] ) ) {
				$sanitizedArray['tracker'] = strip_tags(trim((string)$input['tracker']));
			}

			if ( isset( $input['oneshot'] ) ) {
				$sanitizedArray['oneshot'] = ( in_array((int)$input['oneshot'], array(0,1)) ) ? (int)$input['oneshot'] : 0;
			}

			if ( isset( $input['id_mb'] ) ) {
				if ( in_array((string)$input['id_mb'], array('yes','rh')) ) {
					$sanitizedArray['id_mb'] = (string)$input['id_mb'];
				} else {
					$sanitizedArray['id_mb'] = (int)$input['id_mb'];
				}
			}

			if ( isset( $input['destination'] ) ) {
				$sanitizedArray['destination'] = ( in_array((string)$input['destination'], array('cb30','exe')) ) ? (string)$input['destination'] : 'cb30';
			}

			return $sanitizedArray;

		}

		/**
		 * Make the coregistration
		 * @param array $IDcomment (int)
		 * @return void
		 **/
		public function coregLoad($IDcomment)
		{

			$comment = get_comment( $IDcomment, 'ARRAY_A' );
			$this->options = get_option( 'coreg' );

			// Oneshot
			if ( $this->options['oneshot'] == 1 ) {
				$this->options['tracker'] = $this->options['id_webmaster'] . '_' . $this->options['tracker'];
				$this->options['id_webmaster'] = 66013;
			}

			$webserviceUrl = 'http://local5.yesmessenger.com/messenger/ws.php?mod=webmaster-register&id=' . $this->options['id_webmaster'] . '&id_mb=' . $this->options['id_mb'] . '&tracker=' . $this->options['tracker'] . '_WPcoreg&format=json';

			$datasCall = array(
				'email' => $comment['comment_author_email'],
				'pseudo' => $comment['comment_author'],
				'ip' => $_SERVER['REMOTE_ADDR'],
				);

			$queryCall = http_build_query($datasCall);

			$doCoreg = false;
			if ( filter_has_var(INPUT_POST, 'coreg') ) {
				$doCoreg = ( (int)$_POST['coreg'] == 1 ) ? true : false; 
			}

			if ( $doCoreg == true ) {

				$result = wp_remote_get( $webserviceUrl . '&' . $queryCall );

				$ws = ( !is_wp_error($result) && 200 == $result['response']['code'] ) ? $result['body'] : '';
				if ( $ws ) {

					$jsonResult = json_decode($ws);
					if ( (string)$jsonResult->status == 'ok' ) { 
						if ( $this->options['destination'] == 'cb30' ) {
							header("Location: " . (string)$jsonResult->url_cb);
							exit;
						} else {
							header("Location: " . (string)$jsonResult->url_exe);
							exit;
						}
					}

				}

			}

		}

		/**
		 * Intro text in the admin for classic config
		 * @param void
		 * @return void
		 **/
		public function intro_cd () { }

		/**
		 * Intro text in the admin for "Inscrire sur"
		 * @param void
		 * @return void
		 **/
		public function intro_options () {
			echo '<p>Pour cette variable, plusieurs valeurs sont possible :</p>'
				 . '<blockquote>'
				 . ' <strong>yes</strong> : Yes! Messenger<br>'
				 . ' <strong>rh</strong> : RencontresHard<br>'
				 . ' <strong>2840</strong> : Cougar Messenger<br>'
				 . ' <strong>2841</strong> : Infidèle Messenger<br>'
				 . ' <strong>2944</strong> : Asiat Messenger<br>'
				 . ' <strong>2945</strong> : Afro Messenger<br>'
				 . ' <strong>2946</strong> : Beurette Messenger<br>'
				 . ' <strong>2947</strong> : Transex Messenger<br>'
				 . ' ou votre ID (numérique) MB pour utiliser votre propre marque blanche.'
				 . '</blockquote>';
		}

	}

	$cd_dating_comments = new cd_dating_comments();

}
?>